#include <stdio.h>
#include "crack.h"

#define LTOOLSRV_PORT 1605

CRACK_TCP_PARAMS tcpParams;

void tcpCallbackFcn(CRACK_TCP_PARAMS *params, char *buffer, int numBytesReceived)
{   FILE *fd;
    int n;
    char buf[4096], *p, *q;
    
    printf("Receive TCP command:>>>>>%s<<<<<\n", buffer);
    if ((p = strtok(buffer, "\n"))==NULL)
    	return;
    if ((p = strtok(NULL, "\n"))==NULL)
    	return;
    printf("Pipe command       :>>>>>%s<<<<<\n", p);
    
    if ((q=strstr(p,"-x"))==NULL)
    	return;
    q[0]=' ';
    q[1]=' ';
    printf("Pipe command       :>>>>>%s<<<<<\n", p);
    
    if ((fd=_popen(p,"rt"))==NULL)
    {	printf("LTOOLSRV ERROR: Could not open command pipe\n");
    	return;
    }
    	
    while(1)
    {	if (fgets(buf, sizeof(buf), fd)==NULL)
   	    break;
    	printf(">>>>>%s<<<<<\n",buf);
    	CrackSendTcpData(params, buf, strlen(buf));
    }
    printf("LTOOLSRV INFO: Command pipe closed\n");
    _pclose(fd);
}

void tcpInfoCallback(CRACK_TCP_PARAMS *params)
{   switch(params->tcpStatus)
    {	case(PASSIVE):	printf("LTOOLSRV INFO: Status changed to PASSIVE\n");
    			break;
    	case(LISTEN):	printf("LTOOLSRV INFO: Status changed to LISTEN\n");
    			break;
    	case(ACTIVE):	printf("LTOOLSRV INFO: Status changed to ACTIVE\n");
    			break;
    	default:	printf("LTOOLSRV INFO: Status changed to unknown\n");
    			break;
    }
}

void main(int argc, char* argv[])
{   
    if (CrackCreateTcpServer(LTOOLSRV_PORT, &tcpParams, tcpCallbackFcn, tcpInfoCallback))
    {	printf("LTOOLSRV ERROR: Could not install TCP/IP server\n");
    	exit(-1);
    } 
    
    while(1)
    {	Sleep(500);
    }
}